# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Classes**

* [`sshkeymgmt`](#sshkeymgmt): Rollout ssh keys, Unix groups and Unix users

**Defined types**

* [`sshkeymgmt::add_users`](#sshkeymgmtadd_users): User defined resource add_user
* [`sshkeymgmt::create_user`](#sshkeymgmtcreate_user): User defined resource to create unix users

## Classes

### sshkeymgmt

Create Unix users and Unix groups and roll out the ssh keys of the users.
Groups of users can be defined and rolled out.
A user is regarded as a user group with only one member.

#### Examples

##### 

```puppet
include sshkeymgmt
```

#### Parameters

The following parameters are available in the `sshkeymgmt` class.

##### `users`

Data type: `Hash`

Hash with all defined Unix users

##### `groups`

Data type: `Hash`

Hash with all defined Unix groups

##### `ssh_key_groups`

Data type: `Hash`

Group of users to deploy on a host together with their aah keys

##### `authorized_keys_base_dir`

Data type: `String`

Base directory where to place ssh authorized keys files. Set this parameter if authorized keys files should not be located in user's
home directory

Default value: ''

##### `authorized_keys_owner`

Data type: `String`

This parameter must be set if authorized_keys_base_dir is not empty. This parameter sets the owner of the authorized keys file.

Default value: ''

##### `authorized_keys_group`

Data type: `String`

This parameter must be set if authorized_keys_base_dir is not empty. This paremeter sets the group of the authorized keys file.

Default value: ''

##### `authorized_keys_permissions`

Data type: `String`

This parameter must be set if authorized_keys_base_dir is not empty. This parameter sets the file permissions of the
authorized keys file.

Default value: ''

##### `authorized_keys_base_dir_permissions`

Data type: `String`

The permissions of the directory containing the ssh kex files if not stored within the user's home directory.

Default value: ''

## Defined types

### sshkeymgmt::add_users

Add users together with their ssh keys to the local uasers on an Unix host

#### Parameters

The following parameters are available in the `sshkeymgmt::add_users` defined type.

##### `ssh_users`

Data type: `Array`

List of users

### sshkeymgmt::create_user

Create Unix users

#### Parameters

The following parameters are available in the `sshkeymgmt::create_user` defined type.

##### `uid`

Data type: `Integer`

Numeric uid

##### `gid`

Data type: `Integer`

Numeric group id

##### `homedir`

Data type: `String`

Home directory of the user. If empty it will be created from '/home' and the username

Default value: ''

##### `comment`

Data type: `String`

Comment describing the user

Default value: ''

##### `shell`

Data type: `String`

The Unix shell foer the user

Default value: '/bin/bash'

##### `password`

Data type: `String`

The password to be set

Default value: '!!'

##### `ensure`

Data type: `Enum['present', 'absent']`

Ensure if the user is present or absent. Valid values are 'present' or 'absent'.

Default value: 'present'

##### `groups`

Data type: `Array`

additional groups the user should belong to

Default value: []

##### `sshkeys`

Data type: `Array`

ssh keys to be added to the users authorized_keys file

Default value: []

